#include <stdio.h>
#include <stdlib.h>
#include "../..//annot_region_tools.h"
#include "../../gff_utils.h"
#include "../../../../utils/ansi_string/ansi_string.h"
#include "../../../../genomics_utils/genome_sequence/genome_sequence_tools.h"
#include "../../../..//utils/ansi_cli/config.h"
//#include "consensus_transcript_representation.h"
#include "worm_data_processing.h"

/*
Load, restructure, and process the transcripts to get the consensus transcript information for the worm
transcripts from the GFF file.
*/
//vector<t_transcript_info*>* get_worm_transcript_info_per_GFF(t_config* config)
//{
//	char worm_gff_fp[1000];
//	if(!config->get_str_val("worm_transcript_gff", worm_gff_fp))
//	{
//		fprintf(stderr, "Enter worm transcripts GFF file path.\n");
//		exit(0);
//	}
//
//	char worm_genome_dir[1000];
//	if(!config->get_str_val("worm_genome_dir", worm_genome_dir))
//	{
//		fprintf(stderr, "Enter worm directory path.\n");
//		exit(0);
//	}
//
//	// Load the GFF file.
//	fprintf(stderr, "Loading transcripts from GFF at %s\n", worm_gff_fp);
//	vector<t_annot_region*>* gff_entries = load_GFF(worm_gff_fp);
//
//	// Get the transcripts.
//	fprintf(stderr, "Extracting the transcripts.\n");
//	vector<t_annot_region*>* transcript_regions = get_gff_regions_per_feature_type(gff_entries, "transcript");
//
//	fprintf(stderr, "Have %d worm transcripts.\n", transcript_regions->size());
//	//getc(stdin);
//
//	// Get the exons.
//	fprintf(stderr, "Extracting the exons.\n");
//	vector<t_annot_region*>* exon_regions = get_gff_regions_per_feature_type(gff_entries, "exon");
//	fprintf(stderr, "Have %d worm exons.\n", exon_regions->size());
//	//getc(stdin);
//
//	// Associate the exons to transcripts.
//	fprintf(stderr, "Associating exons to transcripts.\n");
//	associate_gff_children_2_parents(transcript_regions, exon_regions,
//		&get_worm_gff_parent_transcript_ids, // Use this to extract the id for the parent using the group string for child.
//		&get_worm_gff_transcript_id); // Use this to extract the id for the parent using the group string for parent.
//
//	// Exclude the stuff that is already annotated in the included annotations.
//	char worm_annotations_fp[1000];
//	if(!config->get_str_val("worm_annotations", worm_annotations_fp))
//	{
//		fprintf(stderr, "Enter worm annotations path.\n");
//		exit(0);
//	}
//
//	// Load the annotations that will be excluded.
//	fprintf(stderr, "Loading worm transcript annotations to be excluded.\n");
//	//vector<t_annot_region*>* annotated_worm_transcripts = load_GFF(worm_annotations_fp);
//	vector<t_annot_region*>* annotated_worm_transcripts = load_BED(worm_annotations_fp);
//
//	// Exclude the annotated genes
//	fprintf(stderr, "Excluding the transcripts from annotations.\n");
//	vector<t_annot_region*>* excluded_worm_transcripts = exclude_annot_regions(transcript_regions, annotated_worm_transcripts, true);
//
//	fprintf(stderr, "%d transcripts are left in the candidate list.\n", excluded_worm_transcripts->size());
//
//	// Initialize the transcript info list for worm for the excluded stuff.
//	vector<t_transcript_info*>* worm_transcript_info_list = new vector<t_transcript_info*>();
//	for(int i_t = 0; i_t < excluded_worm_transcripts->size(); i_t++)
//	{
//		char* cur_transcript_id = (*get_worm_gff_transcript_id)(excluded_worm_transcripts->at(i_t));
//		fprintf(stderr, "%s (%d exons) %s:%d-%d\n", cur_transcript_id, excluded_worm_transcripts->at(i_t)->intervals->size(), 
//					excluded_worm_transcripts->at(i_t)->chrom, 
//						excluded_worm_transcripts->at(i_t)->start, 
//						excluded_worm_transcripts->at(i_t)->end);
//
//		delete [] cur_transcript_id;
//		getc(stdin);
//
//		// Allocate the transcript info.
//		t_transcript_info* cur_trans_info = new t_transcript_info();
//		cur_trans_info->transcript_region = excluded_worm_transcripts->at(i_t);
//
//		cur_trans_info->transcript_sequence = NULL;
//
//		worm_transcript_info_list->push_back(cur_trans_info);
//	} // i_t loop.
//
//	// Extract the sequences.
//	extract_worm_transcript_sequences(worm_genome_dir,
//											worm_transcript_info_list);
//
//	return(NULL);
//}

//void extract_worm_transcript_sequences(char* worm_genome_dir,
//	vector<t_transcript_info*>* transcript_info_list)
//{
//	// Go over all the transcripts and extract the sequence information per exons and concatenate them.
//	//fprintf(stderr, "Loaded  GFF at %s\n", worm_gff_fp);
//	for(int i_t = 0; i_t < transcript_info_list->size(); i_t++)
//	{
//		t_annot_region* cur_transcript_region = transcript_info_list->at(i_t)->transcript_region;
//
//		char* cur_transcript_sequence = new char[cur_transcript_region->end - cur_transcript_region->start + 2];
//		cur_transcript_sequence[0] = 0;
//		
//		char* cur_transcript_id = (*get_worm_gff_transcript_id)(transcript_info_list->at(i_t)->transcript_region);
//		fprintf(stderr, "Extracting sequence for %s (%d exons) %s:%d-%d:\n", cur_transcript_id, cur_transcript_region->intervals->size(), 
//					cur_transcript_region->chrom, 
//						cur_transcript_region->start, 
//						cur_transcript_region->end);
//
//		// For the current transcript, go over all the exons, concatenate the exon sequences to get the transcript sequence.
//		for(int i_e = 0; i_e < cur_transcript_region->intervals->size(); i_e++)
//		{
//			// A simple sanity check: Do the exons match the strand? Also do they comply with the coordinates of the transcript?
//			if(cur_transcript_region->intervals->at(i_e)->strand != cur_transcript_region->strand)
//			{
//				fprintf(stderr, "The strands are not matching for transcript %s:%d-%d and the exon %s:%d-%d\n", 
//				cur_transcript_region->chrom, 
//				cur_transcript_region->start, 
//				cur_transcript_region->end, 
//				cur_transcript_region->intervals->at(i_e)->chrom, 
//				cur_transcript_region->intervals->at(i_e)->start, 
//				cur_transcript_region->intervals->at(i_e)->end);
//
//				getc(stdin);
//			}
//
//			if(cur_transcript_region->intervals->at(i_e)->end > cur_transcript_region->end ||
//				cur_transcript_region->intervals->at(i_e)->start < cur_transcript_region->start)
//			{
//				fprintf(stderr, "The coordinates are not compatible %s:%d-%d and the exon %s:%d-%d\n", 
//				cur_transcript_region->chrom, 
//				cur_transcript_region->start, 
//				cur_transcript_region->end, 
//				cur_transcript_region->intervals->at(i_e)->chrom, 
//				cur_transcript_region->intervals->at(i_e)->start, 
//				cur_transcript_region->intervals->at(i_e)->end);
//
//				getc(stdin);
//			}
//
//			// Now can get the sequence for this exon and concatenate it to the sequences.
//			char* cur_exon_sequence = extract_sequence(worm_genome_dir, 
//				cur_transcript_region->intervals->at(i_e)->chrom, 
//				cur_transcript_region->intervals->at(i_e)->start, 
//				cur_transcript_region->intervals->at(i_e)->end, 
//				cur_transcript_region->intervals->at(i_e)->strand, true);
//
//			fprintf(stderr, "Exon: %s:%d-%d:\n%s\n", cur_transcript_region->intervals->at(i_e)->chrom, 
//				cur_transcript_region->intervals->at(i_e)->start, 
//				cur_transcript_region->intervals->at(i_e)->end,
//				cur_exon_sequence);
//
//			if(cur_exon_sequence == NULL)
//			{
//				fprintf(stderr, "Could not extract the sequence for %s:%d-%d\n", cur_transcript_region->intervals->at(i_e)->chrom, 
//				cur_transcript_region->intervals->at(i_e)->start, 
//				cur_transcript_region->intervals->at(i_e)->end);
//				getc(stdin);
//			}
//
//			strcat(cur_transcript_sequence, cur_exon_sequence);
//
//			delete [] cur_exon_sequence;
//
//		} // i_e loop.
//		
//		fprintf(stderr, "%s (%d exons) %s:%d-%d:\n%s\n", cur_transcript_id, cur_transcript_region->intervals->size(), 
//			cur_transcript_region->chrom, 
//				cur_transcript_region->start, 
//				cur_transcript_region->end, 
//				cur_transcript_sequence);
//		delete [] cur_transcript_id;
//
//		transcript_info_list->at(i_t)->transcript_sequence = cur_transcript_sequence;
//
//		getc(stdin);
//	} // i_t loop.
//}


void parse_modEncode_worm_transcript_model_gff_grp_strs(vector<t_annot_region*>* gff_entries)
{
	for(int i_e = 0; i_e < gff_entries->size(); i_e++)
	{
		if(i_e % 1000 == 0)
		{
			fprintf(stderr, "Parsing grp string: %d (%d)      \r", i_e, gff_entries->size());
		}

		t_gff_info* cur_gff_info = (t_gff_info*)(gff_entries->at(i_e)->data);
		char* grp_str = cur_gff_info->group_str;

		// Allocate the property id's and values for this entry.
		cur_gff_info->prop_ids = new vector<char*>();
		cur_gff_info->prop_vals = new vector<char*>();

		t_string* grp_str_str = new t_string(grp_str);
		t_string_tokens* grp_str_tokens = grp_str_str->tokenize_by_chars(";");
		
		for(int i = 0; i < grp_str_tokens->size(); i++)
		{
			//fprintf(stderr, "Prop %s: %s\n", grp_str_tokens->at(i)->str(), grp_str_tokens->at(i+1)->str());
			// Retokenize.
			t_string_tokens* tokens = grp_str_tokens->at(i)->tokenize_by_chars("=");

			if(tokens->size() == 2)
			{
				cur_gff_info->prop_ids->push_back(t_string::copy_me_str(tokens->at(0)->str()));
				cur_gff_info->prop_vals->push_back(t_string::copy_me_str(tokens->at(1)->str()));
			}

			t_string::clean_tokens(tokens);
		} // i loop.

		t_string::clean_tokens(grp_str_tokens);
		delete grp_str_str;
	} // i_e loop.

	fprintf(stderr, "Checking for entries to be duplicated.\n");
	for(int i_e = 0; i_e < gff_entries->size(); i_e++)
	{
		if(i_e % 1000 == 0)
		{
			fprintf(stderr, "Checking %d (%d) entry.      \r", i_e, gff_entries->size());
		}

		t_gff_info* cur_gff_info = (t_gff_info*)(gff_entries->at(i_e)->data);

		// Go over the entries and fork the ones that are necessary.
		for(int i_prop = 1; i_prop < cur_gff_info->prop_vals->size(); i_prop++)
		{
			t_string* cur_val_str = new t_string(cur_gff_info->prop_vals->at(i_prop));
			t_string_tokens* cur_vals = cur_val_str->tokenize_by_chars(",");
			if(cur_vals->size() > 1)
			{
				fprintf(stderr, "Duplicating entries for: %s:%d-%d: %s:%s\n", gff_entries->at(i_e)->chrom, gff_entries->at(i_e)->start, gff_entries->at(i_e)->end, cur_gff_info->prop_ids->at(i_prop), cur_gff_info->prop_vals->at(i_prop));

				// Multiple entries, fork this entry with the multiple values.
				for(int i_tok = 1; i_tok < cur_vals->size(); i_tok++)
				{
					// Copy the whole node, replace the current entry, add it to the gff_entries.
					t_annot_region* dup_entry = copy_gff_entry(gff_entries->at(i_e));

					t_gff_info* dup_gff_info = (t_gff_info*)dup_entry->data;

					//fprintf(stderr, "Replacing: %s:%d-%d: %s -> %s\n", gff_entries->at(i_e)->chrom, gff_entries->at(i_e)->start, gff_entries->at(i_e)->end, cur_vals->at(i_tok)->str(), dup_gff_info->prop_vals->at(i_prop));
					//getc(stdin);

					// Clear the memory for the current value. 
					delete [] dup_gff_info->prop_vals->at(i_prop);

					// Replace the value with the current token.
					dup_gff_info->prop_vals->at(i_prop) = t_string::copy_me_str(cur_vals->at(i_tok)->str());

					// Add the duplicate entry.
					gff_entries->push_back(dup_entry);
				} // i_tok loop.

				// Set the property value of the current entry to the first value.
				// Clear the memory for the current value. 
				delete [] cur_gff_info->prop_vals->at(i_prop);

				// Replace the value with the current token.
				cur_gff_info->prop_vals->at(i_prop) = t_string::copy_me_str(cur_vals->at(0)->str());

				fprintf(stderr, "After duplication entries for: %s:%d-%d: %s:%s\n", gff_entries->at(i_e)->chrom, gff_entries->at(i_e)->start, gff_entries->at(i_e)->end, cur_gff_info->prop_ids->at(i_prop), cur_gff_info->prop_vals->at(i_prop));
			} // value count check.

			t_string::clean_tokens(cur_vals);
			delete cur_val_str;
		} // i_ent loop.
	} // i_e loop.
}

void parse_ENSEMBL_gff_grp_strs(vector<t_annot_region*>* gff_entries)
{
	for(int i_e = 0; i_e < gff_entries->size(); i_e++)
	{
		if(i_e % 1000 == 0)
		{
			fprintf(stderr, "Parsing grp string: %d (%d)      \r", i_e, gff_entries->size());
		}

		t_gff_info* cur_gff_info = (t_gff_info*)(gff_entries->at(i_e)->data);
		char* grp_str = cur_gff_info->group_str;

		// Allocate the property id's and values for this entry.
		cur_gff_info->prop_ids = new vector<char*>();
		cur_gff_info->prop_vals = new vector<char*>();

		t_string* grp_str_str = new t_string(grp_str);
		t_string_tokens* grp_str_tokens = grp_str_str->tokenize_by_chars(";=\" ");

		int i = 0; 
		while(i < grp_str_tokens->size())
		{
			if(i+1 >= grp_str_tokens->size())
			{
				fprintf(stderr, "Could not parse the GENCODE gff group string:\n%s\n", grp_str);
				exit(0);
			}

			//fprintf(stderr, "Prop %s: %s\n", grp_str_tokens->at(i)->str(), grp_str_tokens->at(i+1)->str());

			cur_gff_info->prop_ids->push_back(t_string::copy_me_str(grp_str_tokens->at(i)->str()));
			i++;

			cur_gff_info->prop_vals->push_back(t_string::copy_me_str(grp_str_tokens->at(i)->str()));
			i++;
		} // i loop.

		t_string::clean_tokens(grp_str_tokens);
		delete grp_str_str;
	} // i_e loop.

	//fprintf(stderr, "Checking for entries to be duplicated.\n");
	//for(int i_e = 0; i_e < gff_entries->size(); i_e++)
	//{
	//	if(i_e % 1000 == 0)
	//	{
	//		fprintf(stderr, "Checking %d (%d) entry.      \r", i_e, gff_entries->size());
	//	}

	//	t_gff_info* cur_gff_info = (t_gff_info*)(gff_entries->at(i_e)->data);

	//	// Go over the entries and fork the ones that are necessary.
	//	for(int i_prop = 0; i_prop < cur_gff_info->prop_vals->size(); i_prop++)
	//	{
	//		t_string* cur_val_str = new t_string(cur_gff_info->prop_vals->at(i_prop));
	//		t_string_tokens* cur_vals = cur_val_str->tokenize_by_chars(",");
	//		if(cur_vals->size() > 1)
	//		{
	//			// Multiple entries, fork this entry with the multiple values.
	//			for(int i_tok = 0; i_tok < cur_vals->size(); i_tok++)
	//			{
	//				// Copy the whole node, replace the current entry, add it to the gff_entries.
	//				t_annot_region* dup_entry = copy_gff_entry(gff_entries->at(i_e));

	//				t_gff_info* dup_gff_info = (t_gff_info*)dup_entry->data;

	//				// Clear the memory for the current value. 
	//				delete [] dup_gff_info->prop_vals->at(i_prop);

	//				// Replace the value with the current token.
	//				dup_gff_info->prop_vals->at(i_prop) = t_string::copy_me_str(cur_vals->at(i_tok)->str());

	//				// Add the duplicate entry.
	//				gff_entries->push_back(dup_entry);
	//			} // i loop.
	//		} // value count check.

	//		t_string::clean_tokens(cur_vals);
	//		delete cur_val_str;
	//	} // i_ent loop.
	//} // i_e loop.
}

char* get_worm_gff_transcript_id(t_annot_region* gff_entry)
{
	t_gff_info* cur_gff_info = (t_gff_info*)(gff_entry->data);
	char* grp_str = cur_gff_info->group_str;

	// Parse the parent group string.
	t_string* grp_str_str = new t_string(grp_str);
	t_string_tokens* grp_str_tokens = grp_str_str->tokenize_by_chars(";");

	// Find the string that starts with "ID=Transcript:"
	bool found_parent = false;
	for(int i_t = 0; 
		!found_parent && i_t < grp_str_tokens->size(); 
		i_t++)
	{
		if(t_string::prefix_matches(grp_str_tokens->at(i_t)->str(), "ID=Transcript:", false))
		{
			// Copy the transcript id.
			char* parent_transcript_id = t_string::substring(grp_str_tokens->at(i_t)->str(), strlen("ID=Transcript:"), grp_str_tokens->at(i_t)->length());

			t_string::clean_tokens(grp_str_tokens);
			delete(grp_str_str);

			return(parent_transcript_id);
		}
	}

	fprintf(stderr, "Could not extract the transcript id for %s\n", grp_str);
	getc(stdin);
	return(NULL);
}

vector<char*>* get_worm_gff_parent_transcript_ids(t_annot_region* gff_entry)
{
	t_gff_info* cur_gff_info = (t_gff_info*)(gff_entry->data);
	char* grp_str = cur_gff_info->group_str;

	vector<char*>* vector_parent_transcript_ids = new vector<char*>();

	// Parse the parent group string.
	t_string* grp_str_str = new t_string(grp_str);
	t_string_tokens* grp_str_tokens = grp_str_str->tokenize_by_chars(";");

	// Find the string that starts with "ID=Transcript:"
	bool found_parent = false;
	for(int i_t = 0; 
		!found_parent && i_t < grp_str_tokens->size(); 
		i_t++)
	{
		if(t_string::prefix_matches(grp_str_tokens->at(i_t)->str(), "Parent", false))
		{
			// Tokenize the match and get the list of parent transcripts for this child.
			t_string_tokens* parent_ids = grp_str_tokens->at(i_t)->tokenize_by_str("Transcript:");

			// Add all the parent ids, skip the first id, add remaining ones.
			for(int i_p = 1; i_p < parent_ids->size(); i_p++)
			{
				// Get rid of the last comma if it is there.
				char* new_parent_id = t_string::copy_me_str(parent_ids->at(i_p)->str());
				int l_parent_id = strlen(new_parent_id);
				if(new_parent_id[l_parent_id-1] == ',')
				{
					new_parent_id[l_parent_id-1] = 0;
				}

				vector_parent_transcript_ids->push_back(new_parent_id);
			} // i_p loop.
		}
	} // i_t loop.

	return(vector_parent_transcript_ids);
}