#ifndef __WORM_DATA_PROCESSING__
#define __WORM_DATA_PROCESSING__

#include <vector>
using namespace std;

struct t_transcript_info;
class t_config;
struct t_annot_region;

// Load the worm trancripts, then restructure them to get the transcript information and the exons.
vector<t_transcript_info*>* get_worm_transcript_info_per_GFF(t_config* config);

// Following are for associating worm exons to transcripts.
char* get_worm_gff_transcript_id(t_annot_region* gff_entry);
vector<char*>* get_worm_gff_parent_transcript_ids(t_annot_region* gff_entry);

void extract_worm_transcript_sequences(char* worm_genome_dir,
	vector<t_transcript_info*>* transcript_info_list);

// Following parses all the group strings and sets up the list of entries for each gff entry.
void parse_ENSEMBL_gff_grp_strs(vector<t_annot_region*>* gff_entries);
void parse_modEncode_worm_transcript_model_gff_grp_strs(vector<t_annot_region*>* gff_entries);

#endif // __WORM_DATA_PROCESSING__